program ShuffleDeck;
type
   Suit = (Clubs := 0, Diamonds, Hearts, Spades);
   LowRank = 2..10;
   Court = (Jack := High (LowRank)+1, Queen, King, Ace);
   Card = record
      suit : Suit;
      case IsFace : Boolean of
         True: (face : Court);
         False: (rank : LowRank)
   end;
const
   SuitNames : array[Clubs..Spades] of String
      = ('Trefl', 'Karo', 'Kier', 'Pik');
   FaceNames : array[Jack..Ace] of String
      = ('Walet', 'Dama', 'Król', 'As');
   N =
      (Ord (High (Court)) - Ord (Low (LowRank)) + 1) * 4 - 1;
var
   Deck : array[0..N] of Card;
   r, i, pos : Integer;
   s : Suit;
   c : Card;
begin
   for s in Suit do
      for r in [Low (LowRank)..Ord (High (Court))] do
      begin
         with Deck[(r - Low (LowRank))*4 + Ord (s)] do
         begin
            suit := s; IsFace := (r >= Ord (Low (Court))); rank := r
         end
      end;
   for i := 0 to N do
   begin
      pos := i + random (N-i+1);
      c := Deck[pos];
      Deck[pos] := Deck[i];
      Deck[i] := c
   end;
   for i := 0 to N do
      if ParamStr(1) = 'pl' then begin
         if Deck[i].IsFace then
            WriteLn (FaceNames[Deck[i].face], ' ', SuitNames[Deck[i].suit])
         else
            WriteLn (Deck[i].rank, ' ', SuitNames[Deck[i].suit]);
      end else begin
         if Deck[i].IsFace then
            WriteLn (Deck[i].face, ' of ', Deck[i].suit)
         else
            WriteLn (Deck[i].rank, ' of ', Deck[i].suit);
      end         
end.
